$(document).on('pageshow', '#contactDetailsPage', function(event) {
	var id = getUrlVars()["id"],
		btn = $('#btnSaveContact'),
		contacts = JSON.parse(localStorage.getItem('contacts'));

	var data = $.grep(contacts, function(item){
      return item.id == id;
    });

    if(data.length>0){
    	btn.removeClass('ui-disabled');
		displayContact(data[0]);

		btn.on('click', function(){
			// Save contact here
			function onSuccess(contact) {
			    alert(data[0].name + ' has been saved successfully.');
			};

			function onError(contactError) {
			    alert("Error = " + contactError.code);
			};

			// create a new contact object
			var contact = navigator.contacts.create();
			contact.displayName = data[0].name;
			contact.nickname = data[0].name;

			// populate some fields
			var name = new ContactName();
			name.givenName = data[0].name.substr(0, data[0].name.lastIndexOf(' '));
			name.familyName = data[0].name.substr(data[0].name.lastIndexOf(' ') + 1, data[0].name.length);
			contact.name = name;

			var phoneNumbers = [],
				numbers = data[0].nos.split(",");

			for(var idx = 0; idx < numbers.length; idx++) {
				var number = numbers[idx].substr(numbers[idx].indexOf(":") + 1, numbers[idx].length - 1);
				phoneNumbers.push(new ContactField('mobile', number, true));
			}

			contact.phoneNumbers = phoneNumbers;
			contact.note = 'Added from TruthTakers.';

			// save to device
			contact.save(onSuccess, onError);
		});
	}
	else
	{
		btn.addClass('ui-disabled');
	}
});

function displayContact(contact) {
	$('#contactTitle').text(contact.name);
	
	var id = "#phoneList";
	$(id + ' li').remove();
	var list = $(id);

	var numbers = contact.nos.split(",");

	for(var idx = 0; idx < numbers.length; idx++) {
		var number = numbers[idx].substr(numbers[idx].indexOf(":") + 1, numbers[idx].length - 1);
		list.append('<li><a href="tel:'+ number +'">' + numbers[idx]  + '</a></li>');
	}
	
	list.listview('refresh');
}