$(document).on('pageshow', '#detailsPage', function(event) {
	var id = getUrlVars()["id"],
		type = getUrlVars()["type"];

	var news = JSON.parse(localStorage.getItem(type));

	var data = $.grep(news, function(item){
      return item.id == id;
    });

    if(data.length>0){
		displayNews(data[0]);
	}
	
	var ads = JSON.parse(localStorage.getItem("ads"));
	
	if(ads && ads.length > 0)
	{
		displayAds(ads);  
	} 
});
  
function displayNews(newsItem) {
	var attachments = []; 

		var allImgs = "";
		var imgs = newsItem.img.split('@#:#@');
		var titles = newsItem.titles.split('@#:#@');
		 
		for(var m = 0; m < imgs.length; m++)
		{
			allImgs += '<div class="newsimgcontainer"><img class="stretchFit" id="newsImage" onerror="$(this).hide()" class="newsimage" alt="newsImage" src="' + imageURL + newsItem.id + '_' + m + '_big' + imgs[m] + '" />';
			if(titles.length > m)
			{
				allImgs += "<label>" + titles[m] + "</label>";	
			}
			
			allImgs += '</div>';
			
			attachments.push(imageURL + newsItem.id + '_' + m + '_big' + imgs[m]);
		}
	 
	$("#imagesContainer").append(allImgs);
		
	$('.newsimage').on('click', function(){
		window.open(this.src, '_system'); 
	}); 	

	$(".previmg").hide();
	$(".nextimg").hide();
	if(newsItem.img == '' || imgs.length == 0)
	{
		$('.newsimgcontainer').hide();
	}
	else
	{
		$('.newsimgcontainer:first').show();
	}
	
	if(imgs.length > 1)
	{
		$(".nextimg").show();	
	} 
	
	$(".previmg").on('click', function()
	{
		var current = $('.newsimgcontainer:visible').index();
		if(current >= 1)
		{
			if(current == 1)
			{
				$(".previmg").hide();
			}
			
			$(".nextimg").show();
			$('.newsimgcontainer:visible').hide();
			$('.newsimgcontainer:nth(' + (current - 1) + ')').show();
		} 
	});
	
	$(".nextimg").on('click', function()
	{
		var current = $('.newsimgcontainer:visible').index();
		if(current <= $('.newsimgcontainer').length)
		{ 
			if(current == $('.newsimgcontainer').length - 2)
			{
				$(".nextimg").hide();
			}
			
			$(".previmg").show();
			$('.newsimgcontainer:visible').hide();
			$('.newsimgcontainer:nth(' + (current + 1) + ')').show(); 
		} 
	});

	$('#newsTitle').text(newsItem.title);
	$('#newsDescription').text(newsItem.description);
	$('#newsTimeStamp').text(newsItem.date);

	$('#btnShareNews').on('click', function(){
		navigator.screenshot.save(function(error,res){
            if(error){
            	alert('Oops ! Permission denied.');
            	console.error(error);
            }
            else{
				attachments.push('file://' + res.filePath);
				var options = {
				  message: newsItem.title + " " + newsItem.description + " - Download TruthTakers App from (AppStore and Play Store)",
				  subject: newsItem.title,
				  files: attachments,
				  chooserTitle: 'Pick an app'
				};

				var onSuccess = function(result) {
					attachments.pop('file://' + res.filePath);
				  	console.log("Share completed? " + result.completed); // On Android apps mostly return false even while it's true
				  	console.log("Shared to app: " + result.app); // On Android result.app is currently empty. On iOS it's empty when sharing is cancelled (result.completed=false)
				}

				var onError = function(msg) {
					alert(msg);
				}

				window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
     		}
     	});
	});
}

function getUrlVars() {
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
}
