 
function mergeandunique(list, listdelta, stringKeys) {
    var localFinal = [];
	var ids = [];
	if(list != null)
	{
		$.each(list, function(i, e) 
		{
			if ($.inArray(e.id, ids) == -1) 
			{
				localFinal.push(e); 
				ids.push(e.id); 
			}
		});
	}
	
	if(listdelta != null)
	{
		$.each(listdelta, function(i, e) 
		{
			if ($.inArray(e.id, ids) == -1) 
			{
				localFinal.push(e); 
				ids.push(e.id); 
			}
		});
	}
	
	var arrKeys = stringKeys.split(',');
	return $.grep(localFinal, function(n) {
		  return (arrKeys.indexOf(n.id.toString()) < 0);
		}); 
}

function getItemsByCatergory(data, categorId){
	return $.grep(data.Items, function(n) {
		  return ( n.category === categorId );
		});
}

function getFilteredEntities(data, stringKeys){
	if(!stringKeys)
		return data;

	if(stringKeys.trim().length < 1)
		return data;

	var arrKeys = stringKeys.split(',');
	return $.grep(data, function(n) {
		  return (arrKeys.indexOf(n.id.toString()) < 0);
		});
}

function SortNewsByDate(a, b){
  return formatdate(b.date) - formatdate(a.date);
}

function formatdate(d)
{ 
	var str = d.split(' ');
	var dd = str[0].split('-');
	var result = dd[2] + "-" + dd[1] + "-" + dd[0] + " " + str[1] + " " + str[2];
	return new Date(result);
}

function SortContactsByName(a, b){ 
  var aName = a.name.toLowerCase();
  var bName = b.name.toLowerCase(); 
  return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
}
 
function bindElements(local, contacts, surveys, ads){	
  
	if(local != null)
		displayNewsList('localNews', local, false); 
	if(contacts != null)
		displayContactsList(contacts);
	if(surveys != null)
		displaySurveyList(surveys);
	if(ads != null && ads.length > 0)
		displayAds(ads);    
}

function displayNewsList(type, news, hasToRefreshScroller){
	
	var id = "#" + type + "List";
	$(id + ' li').remove();
	var list = $(id);
	
	for(var idx = 0; idx < news.length; idx++) {
		 
		var imgs = news[idx].img.split('@#:#@');
		for(var m = 0; m < imgs.length; m++)
		{
			imgs[m] = imageURL + news[idx].id + '_' + m + '_small' + imgs[m];
		}
		
		var img = (news[idx].img) 
				? '<img class="ui-li-thumb" onerror="$(this).hide()" src="' + imgs[0] + '"/>'
				: "";

		list.append('<li><a href="newsdetails.html?id=' + news[idx].id + '&type='+ type +'">' +
				'<label class="description">' + news[idx].title + '</label><p>' + 
				img +
				'<label class="descriptiondetail">' + news[idx].description + '</label>' + 
				'<p class="small-font">' + news[idx].date + '</p></p></a></li>');
	}
	$("#" + type + "Loader").hide();
	list.listview('refresh');
}

function displayContactsList(contacts){
	if(!contacts){
		$("#contactsLoader").hide();
		return;
	}
	
	contacts.sort(SortContactsByName);
	var id = "#contactList";
	$(id + ' li').remove();
	var list = $(id);

	for(var idx = 0; idx < contacts.length; idx++) {
		list.append('<li><a data-role="button" href="contactDetails.html?id=' + contacts[idx].id+'">' +
				'<label class="description">' + contacts[idx].name + '<p><i>'+ contacts[idx].desc +'</i></p></label>' +
				'<p class="small-font">' + contacts[idx].nos + '</p>'+
				'</a></li>');
	}
	
	$("#contactsLoader").hide();
	list.listview('refresh');
}

function displaySurveyList(survey){
	var id = "#localSurveyList";
	$(id + ' li').remove();
	var list = $(id);
	
	for(var idx = 0; idx < survey.length; idx++) {
		list.append('<li><a href="surveydetails.html?id=' + survey[idx].id + '">' +
				'<h3 class="wrapIt">' + survey[idx].question + '</h3>' +
				'<p class="small-font">Survey # ' + survey[idx].id + '</p></a></li>');
	};
	
	if(survey.length == 0){
		list.append('<li>अभी कोई सर्वे एक्टिव नहीं है, कृपया बाद में कोशिश करे</li>');
	}

	list.listview('refresh');
}
 
var ticker = null;
var currentAdId = 0;
var currentAdIndex = 0;
var adLogic = { Interval : 1000, GetNext : function(idx, id, ads) { return Math.floor(Math.random() * ((ads.length - 1) - 0 + 1)) + 0;} };
			
function displayAds(ads)
{  
	 var topAdBanner = $('#adcontainer img');
	 topAdBanner.show();
	  var idx = adLogic.GetNext(currentAdIndex, currentAdId, ads); 
	  if(idx > -1)	  
	  { 
		  currentAdId = ads[idx];
		  currentAdIndex = idx;   
		  $('#adcontainer a').show().attr('href', ads[idx].url);
		  $(topAdBanner).attr('src', baseURL + "/" + ads[idx].img); 
	  }
	  else
	  {
			$("#adcontainer").css({ height: '0px' });
			$('#adcontainer a').hide();
	  }	
	  
	  if(ticker != null)
			clearInterval(ticker);
		
	  ticker = setInterval(function(){displayAds(ads);}, adLogic.Interval);
}
 
function ModifySpecialContent(content)
{
	adLogic = content;
}
	
function syncAPI(){	 
 
	if(typeof(device) == "undefined")
	{
		var uuid = localStorage.getItem("uuid");
		if(uuid == null)
		{
			uuid = "custom" + Math.floor((Math.random() * 1000000) + 1);
			localStorage.setItem("uuid", uuid)
		}
		
		device = { uuid : uuid};
	}
	
	var local = JSON.parse(localStorage.getItem("localNews")), 
		surveys = JSON.parse(localStorage.getItem("surveys")),
		contacts = JSON.parse(localStorage.getItem("contacts")),
		ads = JSON.parse(localStorage.getItem("ads")),
		syncId = localStorage.getItem("syncId");
		if(syncId == null || syncId == "null")
			syncId = "0"; 

		if(local != null)
		local.sort(SortNewsByDate);	
		 
		bindElements(local, contacts, surveys , ads);  
		$.getJSON(serviceURL + syncId + '/' + device.uuid, function(data) {
			 
			local = mergeandunique(data.Items, local, data.N); 		
			local.sort(SortNewsByDate);		
			local = local.slice(0, 50);
			
			surveys = mergeandunique(data.Surveys, surveys, data.S);   
			contacts = mergeandunique(data.Contacts, contacts, data.C);   
			ads = mergeandunique(data.Ads, ads, data.A);   
			
			localStorage.setItem("localNews", JSON.stringify(local)); 
			localStorage.setItem("contacts", JSON.stringify(contacts));
			localStorage.setItem("surveys", JSON.stringify(surveys));
			localStorage.setItem("ads", JSON.stringify(ads));
			localStorage.setItem("syncId", data.I);  
			bindElements(local, contacts, surveys, ads); 
		});
		
		$.getScript(baseURL + "/Home/SpecialContent");
}

$(document).on('pageshow', '#newsListPage', function(event) {
	//alert('pageshow -');
	//syncAPI();
});

$('#newsListPage').on('pageinit', function(event) { 
	 	
	//alert('pageinit -');	 
			
	$("#refresh").on('click', function() 
	{
		 syncAPI();	
	}); 
});

$(document).on('pagebeforeshow', '#newsListPage', function(){ 
	   
	//alert('pagebeforeshow -' + device.uuid);	 
	///syncAPI();
		
	if(localStorage.getItem("ads") !== null)
	{	
		$("#adcontainer").css({ height: '70px' });
	}
	
	fixHeight(); 
	
});
