
$(document).on('pageshow', '#surveyDetailsPage', function(event) {
	var id = getUrlVars()["id"];

	var surveys = JSON.parse(localStorage.getItem("surveys"));
             //  console.log(surveys);
	var data = $.grep(surveys, function(item){
      return item.id == id;
    });

    if(data.length>0){
		displaySurvey(data[0]);
	}
});

function displaySurvey(surveyItem) {
	var container = $('#surveyAnswers');
	
	var alreadySumbitted = false;
	if(localStorage.getItem("survey_" + surveyItem.id) == "yes")
	{
		alreadySumbitted = true;
		$("#btnSubmit").hide();
	}
	  
	$.each(surveyItem.answers, function(index, answer) {	
	
		var radioContent = '<input type="radio" data-survey-id="' + surveyItem.id + '" name="answer_group" value="' + answer.id + '">';
		if(alreadySumbitted == true)
			radioContent = "";
		
		container.append(
					$('<label>').html(answer.title + '<span class="answer_' + surveyItem.id + '_' + answer.id + ' vote-count"></span>')
                 		.prepend($(radioContent))
                );

     	if(answer.img){		
			container.append('<img style="padding-left:15px;" src="' + imageURL + 'answer_' + surveyItem.id + '_' + answer.id +'_small' + answer.img + '" />');
		}
	});
	
	$('#surveyTitle').text(surveyItem.question);
	
	if(alreadySumbitted == true)
		displayResult(surveyItem.id, 0);
}

function displayResult(id, answer, callback)
{
	$.ajax({
	   url: baseURL + '/api/submitSurvey/' + id + '/' + answer + '/'+ device.uuid +'/1',
	   success: function(result) {
	   		$.each(result, function(index, answerPercentage) {	   			
				var answerLabel = $(".answer_" + id + '_' + answerPercentage.id);
				if(answerLabel){
					answerLabel.html(answerPercentage.percentage +'%');
				}
	   		});
			
			if(callback != null)
			{
				callback(true);
			}  
	   }
	});
}

function getUrlVars() {
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
}

$(document).on('click', "#surveyDetailsPage #btnSubmit", function(){
	var messageBox = $("#surveyDetailsPage #responseMessage");
	var selectedAnswer = $("#surveyDetailsPage #surveyAnswers :radio:checked");

	if(!selectedAnswer || selectedAnswer.length == 0){
		messageBox.html('Please select an answer first.');
		messageBox.popup("open"); 
        setTimeout(function(){  messageBox.popup("close"); }, 2500);
        return false;
	}
 
    localStorage.setItem("survey_" + selectedAnswer.data("survey-id"), "yes");
	  
	displayResult(selectedAnswer.data("survey-id"), selectedAnswer.val(), function(result) {
		
		$("[name='answer_group']").hide(); 
		$("#btnSubmit").hide();
		
	});
});
